From 421a250d7808f592ffbb08e733d0c16b96dd48ff Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Sep 02 2020 04:24:40 +0000
Subject: [PATCH 817/2232] Prefix crate name to the import paths


---

diff --git a/gen/build/src/lib.rs b/gen/build/src/lib.rs
index bdaf4f6..88a1874 100644
--- a/gen/build/src/lib.rs
+++ b/gen/build/src/lib.rs
@@ -126,6 +126,7 @@ fn build(rust_source_files: &mut dyn Iterator<Item = impl AsRef<Path>>) -> Resul
     build.cpp(true);
     build.cpp_link_stdlib(None); // linked via link-cplusplus crate
     write_header(prj);
+    symlink_crate(prj, &mut build);
 
     for path in rust_source_files {
         generate_bridge(prj, &mut build, path.as_ref())?;
@@ -135,10 +136,28 @@ fn build(rust_source_files: &mut dyn Iterator<Item = impl AsRef<Path>>) -> Resul
 }
 
 fn write_header(prj: &Project) {
-    let ref cxx_h = paths::include_dir(prj).join("rust").join("cxx.h");
+    let include_dir = paths::include_dir(prj);
+    let ref cxx_h = include_dir.join("rust").join("cxx.h");
     let _ = write(cxx_h, gen::include::HEADER.as_bytes());
 }
 
+fn symlink_crate(prj: &Project, build: &mut Build) {
+    let manifest_dir = match paths::manifest_dir() {
+        Some(manifest_dir) => manifest_dir,
+        None => return,
+    };
+    let package_name = match paths::package_name() {
+        Some(package_name) => package_name,
+        None => return,
+    };
+
+    let mut link = paths::include_dir(prj);
+    link.push("CRATE");
+    let _ = fs::create_dir_all(&link);
+    let _ = paths::symlink_dir(manifest_dir, link.join(package_name));
+    build.include(link);
+}
+
 fn generate_bridge(prj: &Project, build: &mut Build, rust_source_file: &Path) -> Result<()> {
     let opt = Opt::default();
     let generated = gen::generate_from_path(rust_source_file, &opt);
diff --git a/gen/build/src/paths.rs b/gen/build/src/paths.rs
index 9d922ed..e02246a 100644
--- a/gen/build/src/paths.rs
+++ b/gen/build/src/paths.rs
@@ -19,9 +19,6 @@ pub(crate) fn out_dir() -> Result<PathBuf> {
 pub(crate) fn cc_build(prj: &Project) -> cc::Build {
     let mut build = cc::Build::new();
     build.include(include_dir(prj));
-    if let Some(manifest_dir) = env::var_os("CARGO_MANIFEST_DIR") {
-        build.include(manifest_dir);
-    }
     build
 }
 
@@ -70,7 +67,11 @@ pub(crate) fn include_dir(prj: &Project) -> PathBuf {
     }
 }
 
-fn package_name() -> Option<OsString> {
+pub(crate) fn manifest_dir() -> Option<PathBuf> {
+    env::var_os("CARGO_MANIFEST_DIR").map(PathBuf::from)
+}
+
+pub(crate) fn package_name() -> Option<OsString> {
     env::var_os("CARGO_PKG_NAME")
 }
 
@@ -117,3 +118,11 @@ fn symlink_or_copy(src: &Path, dst: &Path) -> Result<()> {
 
 #[cfg(not(any(unix, windows)))]
 use self::fs::copy as symlink_or_copy;
+
+#[cfg(any(unix, windows))]
+pub(crate) use self::fs::symlink_dir;
+
+#[cfg(not(any(unix, windows)))]
+pub(crate) fn symlink_dir(_src: impl AsRef<Path>, _dst: impl AsRef<Path>) -> Result<()> {
+    Ok(())
+}

